package com.zipcodewilmington.generic.identifiables;

import java.io.Serializable;
import java.lang.reflect.ParameterizedType;
import java.util.Random;

/**
 * @author leon on 05/12/2018.
 */
public class ActionFigure implements IdentifiableInterface<Long> {

    private Long id;

    public ActionFigure(){
        this.id = generateId();
    }

    @Override
    public Long getIdentity() {
        return id;
    }

    public Class<Long> getIdentityType() {
        return (Class) ((ParameterizedType) getClass().getGenericSuperclass()).getActualTypeArguments()[0];
    }

    private Long generateId(){
        return (long) (Math.random() * 10000L);
    }
}
